'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TYPES = {
  LEFT: 'left',
  RIGHT: 'right'
};

var BASE_CLASS = 'sui-AtomInput';
var CLASS_ICON = BASE_CLASS + '--withIcon';
var CLASS_ICON_LEFT = CLASS_ICON + '--' + TYPES.LEFT;
var CLASS_ICON_RIGHT = CLASS_ICON + '--' + TYPES.RIGHT;
var CLASS_ICON_COMPONENT = CLASS_ICON + '-icon';
var CLASS_ICON_COMPONENT_HANDLER = CLASS_ICON_COMPONENT + '--withHandler';
var CLASS_ICON_COMPONENT_LEFT = CLASS_ICON_COMPONENT + '--' + TYPES.LEFT;
var CLASS_ICON_COMPONENT_RIGHT = CLASS_ICON_COMPONENT + '--' + TYPES.RIGHT;

var IconHoC = function IconHoC(WrappedInput) {
  var _class, _temp2;

  return _temp2 = _class = function (_React$Component) {
    (0, _inherits3.default)(Icon, _React$Component);

    function Icon() {
      var _ref;

      var _temp, _this, _ret;

      (0, _classCallCheck3.default)(this, Icon);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Icon.__proto__ || (0, _getPrototypeOf2.default)(Icon)).call.apply(_ref, [this].concat(args))), _this), _this.handleLeftClick = function (e) {
        var onClickLeftIcon = _this.props.onClickLeftIcon;

        onClickLeftIcon && onClickLeftIcon(e);
      }, _this.handleRightClick = function (e) {
        var onClickRightIcon = _this.props.onClickRightIcon;

        onClickRightIcon && onClickRightIcon(e);
      }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(Icon, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            LeftIcon = _props.leftIcon,
            RightIcon = _props.rightIcon,
            onClickLeftIcon = _props.onClickLeftIcon,
            onClickRightIcon = _props.onClickRightIcon,
            props = (0, _objectWithoutProperties3.default)(_props, ['leftIcon', 'rightIcon', 'onClickLeftIcon', 'onClickRightIcon']);

        return LeftIcon || RightIcon ? _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)(CLASS_ICON, LeftIcon && CLASS_ICON_LEFT, RightIcon && CLASS_ICON_RIGHT)
          },
          LeftIcon && _react2.default.createElement(
            'span',
            {
              className: (0, _classnames2.default)(CLASS_ICON_COMPONENT, CLASS_ICON_COMPONENT_LEFT, onClickLeftIcon && CLASS_ICON_COMPONENT_HANDLER),
              onClick: this.handleLeftClick
            },
            _react2.default.createElement(LeftIcon, null)
          ),
          _react2.default.createElement(WrappedInput, props),
          RightIcon && _react2.default.createElement(
            'span',
            {
              className: (0, _classnames2.default)(CLASS_ICON_COMPONENT, CLASS_ICON_COMPONENT_RIGHT, onClickRightIcon && CLASS_ICON_COMPONENT_HANDLER),
              onClick: this.handleRightClick
            },
            _react2.default.createElement(RightIcon, null)
          )
        ) : _react2.default.createElement(WrappedInput, props);
      }
    }]);
    return Icon;
  }(_react2.default.Component), _class.propTypes = {
    /* Left icon component */
    leftIcon: _propTypes2.default.any,

    /* Left icon component */
    rightIcon: _propTypes2.default.any,

    /* Left icon click callback */
    onClickLeftIcon: _propTypes2.default.func,

    /* Right icon click callback */
    onClickRightIcon: _propTypes2.default.func
  }, _temp2;
};

exports.default = IconHoC;